"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
__export(require("./message"));
const OS = require("os");
const SMTP = require("./smtp");
class MailClient {
    get opts() {
        return this._opts;
    }
    constructor(opts) {
        this._opts = opts || {};
        this._opts.domain = this._opts.domain || OS.hostname();
    }
    send(message) {
        return __awaiter(this, void 0, void 0, function* () {
            let client = SMTP.createClient(this._opts);
            return new Promise((res, rej) => {
                client.on('error', function (err) {
                    client.end();
                    rej(err);
                });
                client.mail(message.sender, message.recipients)
                    .on('ready', function () {
                    this.on('end', function () {
                        client.quit();
                        res();
                    }).end(message.toString());
                });
            });
        });
    }
}
exports.MailClient = MailClient;
